//genesis
/* $Id: widglib.g,v 1.5 1997/06/30 18:00:25 venkat Exp $ */
/* $Log: widglib.g,v $
 * Revision 1.5  1997/06/30 18:00:25  venkat
 * Added readonly field "nested" to xform.
 *
 * Revision 1.4  1995/02/04 01:03:29  venkat
 * Added SHOW action for object xform
 *
# Revision 1.3  1994/12/21  21:52:19  dhb
# Added output class tag to all widgets.
#
# Revision 1.2  1994/12/06  00:38:08  dhb
# Nov 8 1994 changes from Upi Bhalla
# */

//==========================================================================
//  name        data            function    class
//==========================================================================

object  xform    xform_type XForm widget output \
    -author     "Maneesh Sahani Caltech July/92" \
    -actions    PROCESS RESET CREATE SET COPY SHOW DELETE XUPDATE \
    -description    "Containing window for other graphical interface objects" \
    -fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		title "" auto_resize "" \
	-readonly nested "Flag to indicate nested/toplevel form" \
	-hidden widget "Pointer to widget for form" \
	-hidden shell "Pointer to widget for shell" \
	-hidden outerframe "Pointer to widget for outer frame" \
	-hidden middleframe "Pointer to widget for middle frame" \
	-hidden innerframe "Pointer to widget for inner frame" \
	-hidden label_w "Pointer to widget for optional label"
//*    -messages   LABEL 0  1 label \        /* type 0: label */
//*    -fields     "label   :   value being displayed" \      */


object  xlabel    xlabel_type XLabel widget output \
    -author     "Maneesh Sahani Caltech July/92" \
    -actions    PROCESS RESET CREATE SET COPY DELETE XUPDATE \
    -description    "Static display for a text string" \
    -fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		label "" font "" \
	-hidden widget "Pointer to widget for label"
//*    -messages   LABEL 0  1 label \        /* type 0: label */
//*    -fields     "label   :   value being displayed" \      */


object  xbutton    xbutton_type XButton widget output \
    -author     "Maneesh Sahani / Upi Bhalla Caltech Feb/93" \
    -actions    PROCESS RESET CREATE SET COPY DELETE XUPDATE \
		B1DOWN B2DOWN B3DOWN XOCOMMAND ANYBDOWN \
    -description    "executes script actions from button presses" \
    -fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		onlabel "" offlabel "" onfg "" offfg "" onbg "" offbg "" \
		onfont "" offfont "" script "" \
	-hidden widget "Pointer to widget for button"
//*    -messages   LABEL 0  1 button \        /* type 0: button */
//*    -fields     "labelon   :   value being displayed" \      */


object  xtoggle    xtoggle_type XToggle widget output \
    -author     "Maneesh Sahani / Upi Bhalla Caltech Feb/93" \
    -actions    PROCESS RESET CREATE SET COPY DELETE XUPDATE \
		B1DOWN B2DOWN B3DOWN XOCOMMAND ANYBDOWN \
		B1UP B2UP B3UP ANYBUP \
    -description    "maintains toggle state and executes script actions from toggle presses" \
    -fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		onlabel "" offlabel "" onfg "" offfg "" onbg "" offbg "" \
		onfont "" offfont "" script "" state "" \
	-hidden widget "Pointer to widget for toggle"

//*    -messages   LABEL 0  1 button \        /* type 0: button */
//*    -fields     "labelon   :   value being displayed" \      */


object  xdialog    xdialog_type XDialog widget output \
    -author     "Maneesh Sahani / Upi Bhalla Caltech May/93" \
    -actions    PROCESS RESET CREATE SET COPY DELETE XUPDATE \
		B1DOWN B2DOWN B3DOWN XOCOMMAND KEYPRESS ANYBDOWN \
    -description    "executes script actions from dialog events" \
	-messages	INPUT 0 1 value \	/* type 0: dialog */
    -fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		value "" script "" label "" font "" fvalue "" \
	-hidden widget "Pointer to widget for dialog"

object xtext	xtext_type XText widget output \
	-author "Maneesh Sahani Caltech / Jason Leigh Univ of Illinois @ Chicago July/93" \
	-actions PROCESS RESET CREATE SET COPY DELETE XOCOMMAND \
		KEYPRESS XUPDATE SAVE2 B1DOWN B2DOWN B3DOWN ANYBDOWN DUMP \
	-description "opens a text editing widget" \
	-fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		initialtext "" editable "" filename "" font "" \
	-hidden hiddentext "internal field with text pointer" \
	-hidden widget "Pointer to widget for text"

// function for loading text from a script file to an xtext
addfunc xtextload do_xtextload


object ximage	ximage_type Ximage widget output \
	-author "Jason Leigh Univ of Illinois @ Chicago July/93, Upi Bhalla" \
	-actions PROCESS RESET CREATE SET COPY DELETE \
		XOCOMMAND B1DOWN B2DOWN B3DOWN ANYBDOWN XUPDATE SAVE2 \
	-description "Displays a gif file" \
	-fields	fg "" bg "" xgeom "" ygeom "" wgeom "" hgeom "" \
		filename "" srcx "" srcy "" dstx "" dsty "" script "" \
	-hidden widget "Pointer to widget for image"
//	-messages None that I know of.

