static char rcsid[] = "$Id: shell_numeric.c,v 1.1 1992/12/11 19:04:39 dhb Exp $";

/*
** $Log: shell_numeric.c,v $
** Revision 1.1  1992/12/11 19:04:39  dhb
** Initial revision
**
*/

#include "shell_ext.h"

float rangauss(mean,var)
float	mean,var;
{
static int saved = FALSE;
static float gsave;
static float oldmean,oldvar;
float 	fac;
float	r,rmax;
float	x,y;

    /*
    ** check for a saved deviate with the same mean and var
    */
    if(saved && (oldmean == mean) && (oldvar == var)){
	saved = FALSE;
	return(gsave);
    } else {
	/*
	** get a random number in the unit circle
	*/
	do {
	    x=frandom(-1,1); 
	    y=frandom(-1,1);
	    r = x*x + y*y;
	} while((r>=1.0) || (r<=0.0));
	fac = sqrt(-2.0*var*log(r)/r);
	/*
	** Box-Muller transformation to get 2 normal deviates
	*/
	gsave = x*fac+mean;		/* save this one */
	oldmean = mean;
	oldvar = var;
	saved = TRUE;
	return(y*fac+mean);		/* return the other */
    } 
}

